#!/bin/sh
#
# Installs a variety of GNOME thumbnailers
#

# Set this to where Gnome is installed
read -p "Enter GNOME install prefix (default is /): " GNOME_PREFIX
[ -n "$GNOME_PREFIX" ] || GNOME_PREFIX=/
echo "  Set GNOME install prefix to '$GNOME_PREFIX'."
export GCONF_CONFIG_SOURCE=xml::$GNOME_PREFIX/etc/gconf/gconf.xml.defaults
echo

read -p "Enter install prefix for thumbnailers (default is /usr/local/bin): " INSTALL_PREFIX
[ -n "$INSTALL_PREFIX" ] || INSTALL_PREFIX=/usr/local/bin
echo "  Set install prefix to '$INSTALL_PREFIX'."
echo
echo

echo "Copying thumbnailer scripts to $INSTALL_PREFIX."
echo "Copying thumbnailer scripts to $INSTALL_PREFIX." | sed 's/./-/g'

for i in vdr
do 
   TITLE=$(sed -n 's/^# Title: //p' gnome-thumbnail-$i)
   NEEDS=$(sed -n 's/^# Needs: //p' gnome-thumbnail-$i)
   TESTS=$(sed -n 's/^# Tests: //p' gnome-thumbnail-$i)
   if [ -z "$TESTS" ] || $TESTS >/dev/null
   then read -p "gnome-thumbnail-$i is $TITLE.
   Install environment seems OK.
   Install gnome-thumbnail-$i [Yn]? " RESULT
        [ "$RESULT" = "n" -o "$RESULT" = "N" ] || cp gnome-thumbnail-$i "$INSTALL_PREFIX"
   else read -p "gnome-thumbnail-$i is $TITLE.
   It needs $NEEDS to function correctly.
   Install gnome-thumbnail-$i anyway [yN]? " RESULT
        [ "$RESULT" = "y" -o "$RESULT" = "Y" ] && cp gnome-thumbnail-$i "$INSTALL_PREFIX"
   fi
   echo
done
echo

echo "Installing schemas for scripts in $INSTALL_PREFIX."
echo "Installing schemas for scripts in $INSTALL_PREFIX." | sed 's/./-/g'

for i in $(ls schemas)
do
  OWNER=$(sed -n 's/.*<owner>\(.*\)<\/owner>/\1/p' "schemas/$i" | head -1)
  MIMES=$(echo $(sed -n 's!.*<key>/schemas/desktop/gnome/thumbnailers/\(.*\)/enable</key>!\1!p' "schemas/$i") | sed 'y! @!,/!')
  if [ -x "$INSTALL_PREFIX/$OWNER" ]
  then
    read -p "Setup thumbnailing of $i files ($MIMES) [yN]? " RESULT
    if [ "$RESULT" = "y" -o "$RESULT" = "Y" ]
    then sed "s!/usr/local/bin!$INSTALL_PREFIX!" schemas/$i > schema.tmp
         gconftool-2 --makefile-install-rule schema.tmp >/dev/null
    fi
  else
    echo "Setup thumbnailer for $i files not possible as $OWNER is not installed."
  fi
done
rm -f schema.tmp
echo

echo "Done."
